function ColorCycle_ExamplifyIt(toggle)
    if (not ColorCycle_ExamplifyitToggler) then ColorCycle_ExamplifyitToggler = false; end    
    if (not toggle) then
        if (not ColorCycle_ExamplifyitToggler) then
            toggle = "on";
        else
            toggle = "off";
        end
    end
    
    if (toggle == "on") then
        if (ColorCycle_Exists) then
        
            -- make the health bar flash from green to red
            ColorCycle_FlashColor( 
                {
                    ID              = "Health Bar";
                    cycleType       = "StatusBar";
                    globalName      = "PlayerFrameHealthBar";
                    colorStart      = "blue";
                    colorEnd        = "red";
                }
            );
            
            -- make the character's portrait pulse red
            ColorCycle_PulseColor( 
                {
                    ID              = "Portrait";
                    cycleType       = "Texture";
                    globalName      = "PlayerPortrait";
                    colorStart      = "white";
                    colorEnd        = "red";
                }
            );
            
           -- make the zone name text drop acid
           ColorCycle_AddTableEntry( 
                {
                    ID              = "Zone Name Text";
                    cycleType       = "FontText";
                    globalName      = "MinimapZoneText";
                    cycleSpeed      = 0.2;
                    varySpeedFactor = 4;
                    okToWait        = {true, true, true};
                }
            );
            
           -- make the player's name change colors in the blue/green hue
           ColorCycle_AddTableEntry( 
                {
                    ID              = "Player Name Text";
                    cycleType       = "FontText";
                    globalName      = "PlayerName";
                    cycleSpeed      = 0.01;
                    varySpeedFactor = 3;
                    okToWait        = {true, true, true};
                    redBounds       = {0.0, 0.0};
                    greenBounds     = {0.3, 1.0};
                    blueBounds      = {0.3, 1.0};
                }
            );

            -- cause the hotkey buttons to cycle through fading up and down
            -- after each key fades it, it calls PlaySound("TellMessage")
            local buttonColor1 = {0.0, 0.0, 0.0};
            local buttonColor2 = {1.0, 1.0, 1.0};
            for i = 1, 12 do
                getglobal("ActionButton"..tostring(i).."Icon"):SetVertexColor(0,0,0);
                ColorCycle_AddTableEntry( 
                    {
                        ID              = "ActionButtons";
                        cycleType       = "Texture";
                        globalName      = "ActionButton"..tostring(i).."Icon";
                        colorStart      = buttonColor1;
                        colorEnd        = buttonColor2;
                        okToWait        = {false, false, false};
                        cycleSpeed      = 0.1;
                        endCondition    = buttonColor2;
                        endingFunction  = {PlaySound, "TellMessage"};
                        unique          = false;
                    }
                );
            end
            for i = 12, 1, -1 do
                ColorCycle_AddTableEntry( 
                    {
                        ID              = "ActionButtons";
                        cycleType       = "Texture";
                        globalName      = "ActionButton"..tostring(i).."Icon";
                        colorStart      = buttonColor2;
                        colorEnd        = buttonColor1;
                        okToWait        = {false, false, false};
                        cycleSpeed      = 0.1;
                        endCondition    = buttonColor1;
                        endingFunction  = {PlaySound, "TellMessage"};
                        unique          = false;
                    }
                );
            end

        end
        ColorCycle_ExamplifyitToggler = true;
        Print("ColorCycle examples are active.");
    elseif (toggle == "off") then
        if (ColorCycle_Exists) then
            ColorCycle_Remove("Experience Status Bar");
            ColorCycle_Remove("Health Bar");
            ColorCycle_Remove("Zone Name Text");
            ColorCycle_Remove("Portrait");
            ColorCycle_Remove("ActionButtons");
            ColorCycle_Remove("Player Name Text");      
        end;

        ColorCycle_ExamplifyitToggler = false;
        Print("ColorCycle examples are inactive.");
    end
end