-- Am trying to keep all the function names really short.
--[[
	Title:		FabFunctions
	Version:	1.8
	Author:		Fabrizio 
	Server:		Dalaran
	Purpose:	To get around limitations when using macro's and build more complex
				macros.
]]--

-- TODO: Optimize all the "Greatest" and "Lowest" functions...
-- TODO: register for "TRAINER_CLOSED" so you can check for higher version of spells.
-- TODO: Key bindings for frames (have them work when the frame is hidden).
-- TODO: SuperMacro?

-- Global Variables
local FFMaxSpellRanks = {};
local MaxLoaded = 0;
AssistTanks = {};
local echoSpell = 0;
local lockFrames = 0;
local LastSpellCast = {};
local GChatEnabled = 1;
FabFunctionSettings = {};

-- Key Bindings
-- Assist Frame Bindings
BINDING_HEADER_ASSISTFRAME = FAB_ASSIST_HEADER;
BINDING_NAME_ASSISTMAINTANK = FAB_BINDING_ASSISTMAINTANK;
BINDING_NAME_ASSISTGREATESTHP = FAB_BIDING_ASSISTGREATESTHP;
BINDING_NAME_ASSISTLEASTHP = FAB_BINDING_ASSISTLEASTHP;
BINDING_NAME_SETASSIST = FAB_BINDING_SETASSIST;

-- Target Frame Bindings
BINDING_HEADER_TARGETFRAME = FAB_TARGET_HEADER;
BINDING_NAME_TARGETLOWESTHP = FAB_BINDING_TARGETLOWESTHP;
BINDING_NAME_TARGETMOSTDAMAGETAKEN = FAB_BINDING_TARGETMOSTDAMAGETAKEN;
BINDING_NAME_TARGETCORPSE = FAB_BINDING_TARGETCORPSE;

-- To figure out the highest rank of every spell the person knows.
FabFunctions_OnLoad = function()
	-- so we can skip "general" skills
	local name, texture, offset, numSpells = GetSpellTabInfo(1);
	local i = numSpells + 1;
	local lastSpellName = "";
	local lastSpellRank = "";
	
	if(MaxLoaded == 0) then
	
		--add slash command
		SlashCmdList["FFUNC"] = FabFunctions_SlashCommand;
		SLASH_FFUNC1 = "/ffunc";
		SlashCmdList["GCHAT"] = FabFunctions_GChatToggle;
		SLASH_GCHAT1 = "/GChat";
		SLASH_GCHAT2 = "/gchat";
	
		-- All tooltips go here
		-- Options Frame
		AssistCheckButton.tooltiptext = ASSISTCHECKBUTTON_TOOLTIP;
		HealCheckButton.tooltiptext = HEALCHECKBUTTON_TOOLTIP;
		BuffCheckButton.tooltiptext = BUFFCHECKBUTTON_TOOLTIP;
		TargetCheckButton.tooltiptext = TARGETCHECKBUTTON_TOOLTIP;
		EchoSpellsCheckButton.tooltiptext = ECHOSPELLSCHECKBUTTON_TOOLTIP;
		LockFramesCheckButton.tooltiptext = LOCKFRAMESCHECKBUTTON_TOOLTIP;
		
		-- Assist Frame
		AssistMT.tooltiptext = ASSISTMT_TOOLTIP;
		AssistGreatestHP.tooltiptext = ASSISTGREATESTHP_TOOLTIP;
		AssistLeastHP.tooltiptext = ASSISTLEASTHP_TOOLTIP;
		SetAssist.tooltiptext = SETASSIST_TOOLTIP;
		
		-- Target Frame
		TargetLowestHP.tooltiptext = TARGETLOWESTHP_TOOLTIP;
		TargetMostDamageTaken.tooltiptext = TARGETMOSTDAMAGETAKEN_TOOLTIP;
		TargetCorpse.tooltiptext = TARGETCORPSE_TOOLTIP;
		
		-- Druid Heal Frame
		Rejuvenation.tooltiptext = REJUVENATION_TOOLTIP;
		Regrowth.tooltiptext = REGROWTH_TOOLTIP;
		HealingTouch.tooltiptext = HEALINGTOUCH_TOOLTIP;
	
		-- Paladin Heal frame
		FlashOfLight.tooltiptext = FLASHOFLIGHT_TOOLTIP;
		HolyLight.tooltiptext = HOLYLIGHT_TOOLTIP;
		
		-- Paladin Buff Frame
		BlessMight.tooltiptext = BLESSMIGHT_TOOLTIP;
		BlessWisdom.tooltiptext = BLESSWISDOM_TOOLTIP;
		BlessSanctuary.tooltiptext = BLESSSANCTUARY_TOOLTIP;
		BlessLight.tooltiptext = BLESSLIGHT_TOOLTIP;
		BlessProtection.tooltiptext = BLESSPROTECTION_TOOLTIP;
	
		-- Priest Heal frame
		Renew.tooltiptext = RENEW_TOOLTIP;
		LesserHeal.tooltiptext = LESSERHEAL_TOOLTIP;
		Heal.tooltiptext = HEAL_TOOLTIP;
		GreaterHeal.tooltiptext = GREATERHEAL_TOOLTIP;
		FlashHeal.tooltiptext = FLASHHEAL_TOOLTIP;
		
		-- Shaman Heal frame
		HealingWave.tooltiptext = HEALINGWAVE_TOOLTIP;
		LesserHealingWave.tooltiptext = LESSERHEALINGWAVE_TOOLTIP;
	
		-- register for events here	
		AssistFrame:RegisterForDrag("LeftButton");
		FabTargetFrame:RegisterForDrag("LeftButton");
		PaladinHealFrame:RegisterForDrag("LeftButton");
		PaladinBuffFrame:RegisterForDrag("LeftButton");
		PriestHealFrame:RegisterForDrag("LeftButton");
		ShamanHealFrame:RegisterForDrag("LeftButton");
		DruidHealFrame:RegisterForDrag("LeftButton");
		
		-- Cover Frame Events Here
		DummyPartyMemberFrame1:RegisterForClicks("RightButtonUp", "LeftButtonUp");
		DummyPartyMemberFrame2:RegisterForClicks("RightButtonUp", "LeftButtonUp");
		DummyPartyMemberFrame3:RegisterForClicks("RightButtonUp", "LeftButtonUp");
		DummyPartyMemberFrame4:RegisterForClicks("RightButtonUp", "LeftButtonUp");
		
		DummyFabFrame:RegisterEvent("VARIABLES_LOADED");
		--DummyFabFrame:RegisterEvent("PARTY_MEMBERS_CHANGED");
		DummyFabFrame:RegisterEvent("RAID_ROSTER_UPDATE");
		
		LastSpellCast["TYPE"] = "NONE";
		
	end
	
	-- Figure out the max ranks of the spells	
	while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);
		
		if(not spellName) then
			FFMaxSpellRanks[lastSpellName] = tonumber(string.sub(lastSpellRank, 6));
			break;
		end
		
		if(lastSpellName ~= spellName) then
			if(lastSpellName ~= "") then
				FFMaxSpellRanks[lastSpellName] = tonumber(string.sub(lastSpellRank, 6));
			end
		end
		
		lastSpellName = spellName;
		lastSpellRank = spellRank;
		
		i = i+1;
	end
	
	if(MaxLoaded == 0) then
		if(DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage("FabFunctions 1.8 Loaded.  Type /ffunc for options.", 1.0, 1.0, 1.0);
		end
	end
end;

FabFunctions_OnClick = function(buttonName)
	
	if(buttonName == "AssistMT") then
		if(AssistTanks[1] ~= nil) then
			FFunc.Assist(AssistTanks[1], AssistTanks[2], AssistTanks[3]);
		end
	elseif(buttonName == "AssistGreatestHP") then	
		FFunc.AssistGreatestHP();
	elseif(buttonName == "AssistLeastHP") then
		FFunc.AssistLeastHP();
	elseif(buttonName == "SetAssist") then
		FFunc.SetAssistThree(-1);
	elseif(buttonName == "FlashOfLight") then
		Paladin.FlashOfLight();
	elseif(buttonName == "HolyLight") then
		Paladin.HolyLight();
	elseif(buttonName == "Renew") then
		Priest.Renew();
	elseif(buttonName == "LesserHeal") then
		Priest.LesserHeal();
	elseif(buttonName == "Heal") then
		Priest.Heal();
	elseif(buttonName == "GreaterHeal") then
		Priest.GreaterHeal();
	elseif(buttonName == "FlashHeal") then
		Priest.FlashHeal();
	elseif(buttonName == "HealingWave") then
		Shaman.HealingWave();
	elseif(buttonName == "LesserHealingWave") then
		Shaman.LesserHealingWave();
	elseif(buttonName == "TargetLowestHP") then
		FFunc.TargetLowestHP();
	elseif(buttonName == "TargetMostDamageTaken") then
		FFunc.TargetMostDamageTaken();
	elseif(buttonName == "TargetCorpse") then
		FFunc.TargetCorpse();
	elseif(buttonName == "HealingTouch") then
		Druid.HealingTouch();
	elseif(buttonName == "Regrowth") then
		Druid.Regrowth();
	elseif(buttonName == "Rejuvenation") then
		Druid.Rejuvenation();
	elseif(buttonName == "BlessMight") then
		Paladin.BlessMight();
	elseif(buttonName == "BlessWisdom") then
		Paladin.BlessWisdom();
	elseif(buttonName == "BlessSanctuary") then
		Paladin.BlessSanctuary();
	elseif(buttonName == "BlessLight") then
		Paladin.BlessLight();
	elseif(buttonName == "BlessProtection") then
		Paladin.BlessProtection();
	end
end;

ClickCast_Unit = function(unit, frameName)

	if(UnitName(unit) == nil) then
		return;
	end
		
	if(LastSpellCast["TYPE"] == "NONE") then
	
		if(arg1 == "LeftButton") then
			if(SpellIsTargeting()) then
				SpellTargetUnit(unit);
			elseif(CursorHasItem()) then
				DropItemOnUnit(unit);
			else
				TargetUnit(unit);
			end
		elseif(arg1 == "RightButton") then
			if(SpellIsTargeting()) then
				SpellStopTargeting();
			else
				ToggleDropDownMenu(1, nil, getglobal("PartyMemberFrame"..getglobal(frameName):GetID().."DropDown"), frameName, 47, 15);
			end			
		end		
		return;
	end 
	
	if(SpellIsTargeting()) then
		SpellStopCasting();
		TargetUnit(unit);
		
		if(LastSpellCast["TYPE"] == "BUFF") then
			Misc.CastBuffSpell(LastSpellCast["NAME"], LastSpellCast["RANK_LEVELS"], LastSpellCast["MAX_RANK"]);
		elseif(LastSpellCast["TYPE"] == "HEAL") then
			Misc.CastHealSpell(LastSpellCast["NAME"], LastSpellCast["HEAL_LEVELS"], LastSpellCast["RANK_LEVELS"],
				LastSpellCast["MAX_RANK"]);
		end
		
		TargetLastTarget();		
		
		LastSpellCast["TYPE"] = "NONE";
	end
end;


DummyFrames_Update = function(name)

	local theFrame = getglobal(name);
	local thePetFrame = getglobal(name.."PetFrame");
	local theID = theFrame:GetID();
	
	local level = theFrame:GetFrameLevel();
	
	if(UnitIsConnected("party"..theID) and UnitExists("partypet"..theID)) then
		thePetFrame:Show();
		thePetFrame:SetPoint("TOPLEFT", this:GetName(), "TOPLEFT", 23, -43);
	elseif(thePetFrame:IsShown()) then
		thePetFrame:Hide();
		thePetFrame:SetPoint("TOPLEFT", this:GetName(), "TOPLEFT", 23, -27);
	end
	
	if(UnitExists("party"..theID)) then
		theFrame:Show();
	else
		theFrame:Hide();
	end
	
	if(name == "DummyPartyMemberFrame1" and theFrame:IsShown()) then
		if(theFrame:GetFrameLevel() < PartyMemberFrame1:GetFrameLevel()) then
			theFrame:Raise();
		end	
		
		if(thePetFrame:IsShown() and (thePetFrame:GetFrameLevel() < PartyMemberFrame1PetFrame:GetFrameLevel())) then
			thePetFrame:Raise();
		end
	elseif(name == "DummyPartyMemberFrame2" and theFrame:IsShown()) then
		if(theFrame:GetFrameLevel() < PartyMemberFrame2:GetFrameLevel()) then
			theFrame:Raise();
		end
		
		if(thePetFrame:IsShown() and (thePetFrame:GetFrameLevel() < PartyMemberFrame2PetFrame:GetFrameLevel())) then
			thePetFrame:Raise();
		end
	elseif(name == "DummyPartyMemberFrame3" and theFrame:IsShown()) then
		if(theFrame:GetFrameLevel() < PartyMemberFrame3:GetFrameLevel()) then
			theFrame:Raise();
		end
		
		if(thePetFrame:IsShown() and (thePetFrame:GetFrameLevel() < PartyMemberFrame3PetFrame:GetFrameLevel())) then
			thePetFrame:Raise();
		end
	elseif(name == "DummyPartyMemberFrame4" and theFrame:IsShown()) then
		if(theFrame:GetFrameLevel() < PartyMemberFrame4:GetFrameLevel()) then
			theFrame:Raise();
		end
		
		if(thePetFrame:IsShown() and (thePetFrame:GetFrameLevel() < PartyMemberFrame4PetFrame:GetFrameLevel())) then
			thePetFrame:Raise();
		end
	end
end;

PartyFrames_Click = function(frameName)
	local unit = "party"..getglobal(frameName):GetID();		
	ClickCast_Unit(unit, frameName);
end;

PetFrames_Click = function(frameName)
	local unit = "party"..getglobal(frameName):GetID().."pet";		
	ClickCast_Unit(unit, frameName);
end;

FabFunctions_CheckClick = function(name)

	local playerClass, englishClass = UnitClass("player");
	local checked = getglobal(name):GetChecked();

	if(name == "AssistCheckButton") then
		if(checked) then
			AssistFrame:Hide();
			FabFunctionSettings["AssistFrame"] = "HIDE";
		else
			if(GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) then
				AssistFrame:Show();
			end
			FabFunctionSettings["AssistFrame"] = "SHOW";
		end
	elseif(name == "HealCheckButton") then
		if(englishClass == "PALADIN") then
			if(checked) then
				PaladinHealFrame:Hide();
			else
				PaladinHealFrame:Show();
			end
		elseif(englishClass == "PRIEST") then
			if(checked) then
				PriestHealFrame:Hide();
			else
				PriestHealFrame:Show();
			end
		elseif(englishClass == "SHAMAN") then
			if(checked) then
				ShamanHealFrame:Hide();
			else
				ShamanHealFrame:Show();
			end
		end
		
		if(checked) then
			FabFunctionSettings["HealFrame"] = "HIDE";
		else
			FabFunctionSettings["HealFrame"] = "SHOW";
		end
	elseif(name == "BuffCheckButton") then
		if(checked) then
			-- hide frames
			if(englishClass == "PALADIN") then
				PaladinBuffFrame:Hide();
			end
			
			FabFunctionSettings["BuffFrame"] = "HIDE";
		else
			-- show frames
			if(englishClass == "PALADIN") then
				PaladinBuffFrame:Show();
			end
			
			FabFunctionSettings["BuffFrame"] = "SHOW";
		end
	elseif(name == "TargetCheckButton") then
		if(checked) then
			FabTargetFrame:Hide();
			FabFunctionSettings["TargetFrame"] = "HIDE";
		else
			if(GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0) then
				FabTargetFrame:Show();
			end
			FabFunctionSettings["TargetFrame"] = "SHOW";
		end	
	elseif(name == "EchoSpellsCheckButton") then
		if(checked) then
			echoSpell = 1;
		else
			echoSpell = 0;
		end
		
		FabFunctionSettings["EchoSpell"] = echoSpell;
	elseif(name == "LockFramesCheckButton") then
		if(checked) then
			lockFrames = 1;
		else
			lockFrames = 0;
		end
		
		FabFunctionSettings["LockFrames"] = lockFrames;
	end
end;

FabFunctions_SlashCommand = function()
	if(not FabFunctOptions:IsVisible()) then
		FabFunctOptions:Show();
	else
		FabFunctOptions:Hide();
	end
end;

FabFunctions_GChatToggle = function()
	if(GChatEnabled == 1) then
		GChatEnabled = 0;
		if(DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage("GChat has been disabled.", 1.0, 1.0, 1.0);
		end
	else
		GChatEnabled = 1;
		if(DEFAULT_CHAT_FRAME) then
			DEFAULT_CHAT_FRAME:AddMessage("GChat is now enabled.", 1.0, 1.0, 1.0);
		end
	end
end;

FabFunctions_Event = function(event)
	if(event == "VARIABLES_LOADED") then
	
		if(FabFunctionSettings == nil) then
			FabFunctionSettings = {};
		end
		
		echoSpell = FabFunctionSettings["EchoSpell"];
		lockFrames = FabFunctionSettings["LockFrames"];
		
		-- show the proper frames.
		local playerClass, englishClass = UnitClass("player");
		
		if(FabFunctionSettings["AssistFrame"] == nil) then
			FabFunctionSettings["AssistFrame"] = "SHOW";
		end
		
		if(FabFunctionSettings["TargetFrame"] == nil) then
			FabFunctionSettings["TargetFrame"] = "SHOW";
		end
		
		if(FabFunctionSettings["BuffFrame"] == nil) then
			FabFunctionSettings["BuffFrame"] = "SHOW";
		end
		
		if(FabFunctionSettings["HealFrame"] == nil) then
			FabFunctionSettings["HealFrame"] = "SHOW";
		end
	
		if((GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) then
			if(FabFunctionSettings["AssistFrame"] == "SHOW") then
				AssistFrame:Show();
			else
				AssistFrame:Hide();
			end
			
			if(FabFunctionSettings["TargetFrame"] == "SHOW") then
				FabTargetFrame:Show();
			else
				FabTargetFrame:Hide();
			end
		else
			AssistFrame:Hide();
			FabTargetFrame:Hide();
		end
		
		if(FabFunctionSettings["AssistFrame"] == "HIDE") then
			AssistFrame:Hide();
			
			AssistCheckButton:SetChecked(1);
		end
		
		if(FabFunctionSettings["TargetFrame"] == "HIDE") then
			TargetFrame:Hide();
			
			TargetCheckButton:SetChecked(1);
		end
		
		if(FabFunctionSettings["BuffFrame"] == "HIDE") then
			PaladinBuffFrame:Hide();
			
			BuffCheckButton:SetChecked(1);
		end
		
		if(FabFunctionSettings["HealFrame"] == "HIDE") then
			PaladinHealFrame:Hide();
			PriestHealFrame:Hide();
			ShamanHealFrame:Hide();
			
			HealCheckButton:SetChecked(1);
		end	
		
		if(FabFunctionSettings["EchoSpell"] == 1) then
			EchoSpellsCheckButton:SetChecked(1);
		end		
		
		if(FabFunctionSettings["LockFrames"] == 1) then
			LockFramesCheckButton:SetChecked(1);
		end
		
		if(englishClass == "SHAMAN") then
			if(FabFunctionSettings["HealFrame"] == "SHOW") then
				ShamanHealFrame:Show();
			else
				ShamanHealFrame:Hide();
			end
		else
			ShamanHealFrame:Hide();
		end
		
		if(englishClass == "PRIEST") then
			if(FabFunctionSettings["HealFrame"] == "SHOW") then
				PriestHealFrame:Show();
			else
				PriestHealFrame:Hide();
			end
			
	--[[		if(FabFunctionSettings["BuffFrame"] == "SHOW") then
				PriestBuffFrame:Show();
			else
				PriestBuffFrame:Hide();
			end]]--
		else
			PriestHealFrame:Hide();
		end
	
		if(englishClass == "PALADIN") then
			if(FabFunctionSettings["HealFrame"] == "SHOW") then
				PaladinHealFrame:Show();
			else
				PaladinHealFrame:Hide();
			end
			
			if(FabFunctionSettings["BuffFrame"] == "SHOW") then
				PaladinBuffFrame:Show();
			else
				PaladinBuffFrame:Hide();
			end
		else
			PaladinHealFrame:Hide();
			PaladinBuffFrame:Hide();
		end
		
		if(englishClass == "DRUID") then
			if(FabFunctionSettings["HealFrame"] == "SHOW") then
				DruidHealFrame:Show();
			else
				DruidHealFrame:Hide();
			end
			
	--[[		if(FabFunctionSettings["BuffFrame"] == "SHOW") then
				DruidBuffFrame:Show();
			else
				DruidBuffFrame:Hide();
			end]]--
		else
			DruidHealFrame:Hide();
		end
		
		-- disable the correct buttons
		if(englishClass == "WARRIOR" or
			englishClass == "ROGUE" or
			englishClass == "HUNTER" or
			englishClass == "MAGE" or
			englishClass == "WARLOCK") then
			
			HealCheckButton:SetChecked(1);
			HealCheckButton:Disable();
		end
		
--[[	elseif(event == "PARTY_MEMBERS_CHANGED") then	
		if(GetNumRaidMembers() > 0 or GetNumPartyMembers() > 0) then
			if(FabFunctionSettings["AssistFrame"] == "SHOW" and not AssistFrame:IsShown()) then
				AssistFrame:Show();
			end
		
			if(FabFunctionSettings["TargetFrame"] == "SHOW" and not FabTargetFrame:IsShown()) then
				FabTargetFrame:Show();
			end
		elseif(GetNumRaidMembers() <= 0 and GetNumPartyMembers() <= 0) then
			if(AssistFrame:IsShown()) then
				AssistFrame:Hide();
			end
		
			if(FabTargetFrame:IsShown()) then
				FabTargetFrame:Hide();
			end
		end		]]--
	elseif(event == "RAID_ROSTER_UPDATE") then
		if(GetNumRaidMembers() > 0 or GetNumPartyMembers() > 0) then
			if(FabFunctionSettings["AssistFrame"] == "SHOW" and not AssistFrame:IsShown()) then
				AssistFrame:Show();
			end
		
			if(FabFunctionSettings["TargetFrame"] == "SHOW" and not FabTargetFrame:IsShown()) then
				FabTargetFrame:Show();
			end
		elseif(GetNumRaidMembers() <= 0 and GetNumPartyMembers() <= 0) then
			if(AssistFrame:IsShown()) then
				AssistFrame:Hide();
			end
		
			if(FabTargetFrame:IsShown()) then
				FabTargetFrame:Hide();
			end
		end	
	end 
end;

FabFunctions_StartDrag = function(name)
	if(lockFrames == 0) then
		getglobal(name):StartMoving();
	end
end;

FabFunctions_StopDrag = function(name)
	if(lockFrames == 0) then
		getglobal(name):StopMovingOrSizing();
	end
end;

Misc = {
-- I had to add this because blizzards way of coding the API is more philosophical than pratical
-- For instance: You are always in your own party, UnitInParty("player") is always true
--  That's philosophical, practical is this:  I'm not grouped with jack jolly shit.  
-- This is why I wrote this:
	IsEnemy = function(unit, otherUnit)
		if(not UnitIsFriend(unit, otherUnit) and not UnitIsEnemy(unit, otherUnit) and UnitCanAttack("player", "target")) then
			return 1;
		end
		
		if(UnitIsEnemy(unit, otherUnit)) then
			return 1;
		else
			return nil;
		end
	end;


-- pretty much all the buff spells in the game work the same way.....so use this to clean it up	
	CastBuffSpell = function(name, buffLevels, maxRank)
		local switchedTargets = 0;
		local spellRank = 1;
		
		-- I have to add this because of how blizzard loads their junk is.....dumb
		if(MaxLoaded == 0) then
			MaxLoaded = 1;
			FabFunctions_OnLoad();
		end
		
		local rank = FFMaxSpellRanks[name];
		
		if(rank == nil) then
			return;
		end
		
		if(rank < 1) then
			rank = 1;
		end
		
		if(rank > maxRank) then
			rank = maxRank;
		end
		
		if((GetNumPartyMembers() == 0) and (GetNumRaidMembers() == 0)) then
			if(UnitName("target") == nil or Misc.IsEnemy("player", "target")) then			
				switchedTargets = 1;
			end
		end
		
		if(((GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) and(UnitName("target") == nil or Misc.IsEnemy("player", "target"))) then
			LastSpellCast["NAME"] = name;
			LastSpellCast["RANK_LEVELS"] = buffLevels;
			LastSpellCast["MAX_RANK"] = maxRank;
			LastSpellCast["TYPE"] = "BUFF";
		end
		
		local level = UnitLevel("target");
		
		if(switchedTargets == 1) then
			level = UnitLevel("player");
		end
		
		for i = rank, 1, -1 do
			if(level >= buffLevels[i] - 10) then
				spellRank = i;
				break;
			end		
		end
		
		CastSpellByName(name.."(Rank "..spellRank..")");
		
		local targetName = UnitName("target");
		
		if((switchedTargets == 1) and SpellIsTargeting()) then
			SpellTargetUnit("player");
			targetName = UnitName("player");
		end
		
		if(echoSpell == 1 and not SpellIsTargeting()) then
			FFunc.GChat("Casting "..name.."(Rank "..spellRank..") on "..targetName);
		end
	end;
	
-- same thing with all the healing spells.  You could also use this for dots, but I wouldn't recommend it
	CastHealSpell = function(name, healLevels, rankLevels, maxRank)
		local spellRank = 1;
		local switchedTargets = 0;
		
		if(MaxLoaded == 0) then
			MaxLoaded = 1;
			FabFunctions_OnLoad();
		end
		
		local rank = FFMaxSpellRanks[name];
		
		if(rank == nil) then
			return;
		end
		
		if(rank < 1) then
			rank = 1;
		end
		
		if(rank > maxRank) then
			rank = maxRank;
		end
		
		if((GetNumPartyMembers() == 0) and (GetNumRaidMembers() == 0)) then
			if((UnitName("target") == nil) or Misc.IsEnemy("player", "target")) then
				switchedTargets = 1;
			end
		end
		
		if(((GetNumPartyMembers() > 0) or (GetNumRaidMembers() > 0)) and(UnitName("target") == nil or Misc.IsEnemy("player", "target"))) then
			LastSpellCast["NAME"] = name;
			LastSpellCast["HEAL_LEVELS"] = healLevels;
			LastSpellCast["RANK_LEVELS"] = rankLevels;
			LastSpellCast["MAX_RANK"] = maxRank;
			LastSpellCast["TYPE"] = "HEAL";
		end

		local damage = UnitHealthMax("target") - UnitHealth("target");	
		local difference = 20000;
		
		if(switchedTargets == 1) then
			damage = UnitHealthMax("player") - UnitHealth("player");
		end
	
		for i=rank, 1, -1 do
			local tempDiff = healLevels[i] - damage;
			
			if(tempDiff < 0) then
				tempDiff = (-tempDiff);
			end
			
			if(tempDiff < difference) then
				difference = tempDiff;
			elseif(tempDiff == difference) then
				spellRank = i;
				break;
			-- tempDiff > difference
			else
				spellRank = i+1;
				break;
			end
		end

		-- Read a post about "predicting" more damage....this will help some..doesn't
		-- fully predict.
		
		if(UnitName("target") ~= nil and (not UnitIsUnit("target", "player")) and UnitIsUnit("targettargettarget", "target")) then
			spellRank = spellRank + 1;
		end
		
		if(spellRank > rank) then
			spellRank = rank;
		end
		
		CastSpellByName(name.."(Rank "..spellRank..")");
		
		local targetName = UnitName("target");

		if((switchedTargets == 1) and SpellIsTargeting()) then
			SpellTargetUnit("player");
			targetName = UnitName("player");
		end
		
		if(echoSpell == 1 and not SpellIsTargeting()) then
			FFunc.GChat("Casting "..name.."(Rank "..spellRank..") on "..targetName);
		end
	end;
};


FFunc = {
--  if in a raid, chat the message there, else chat into party
	GChat = function(message)
		if(GChatEnabled == 1) then
			local language = "COMMON";
		
			if(UnitFactionGroup("player") == "Horde") then
				language = "ORCISH";
			end
		
			if(GetNumRaidMembers() > 0) then
				SendChatMessage(message, "RAID", language);
			elseif(GetNumPartyMembers() > 0) then
				SendChatMessage(message, "PARTY", language);
			end
		end
	end;
	
-- equipment swapping....didn't want invSlot, but it fixes ambiguity issues
	Equip = function(bag, bagSlot, invSlot)
		PickupContainerItem(bag, bagSlot);
		PickupInventoryItem(invSlot);
	end;

-- find a party member who is targetting something that has the least HP
-- Haven't tested in a 40 person raid.....may be quite slow on a large raid...
	AssistLeastHP = function()
	
		local numRaidMembers = GetNumRaidMembers();
		local numPartyMembers = GetNumPartyMembers();
	
		if(numRaidMembers > 0) then
			local lowestId = -1;
			local lowestHP = 200;
			
			for i=1, numRaidMembers, 1 do
				local name = "raid"..i.."target";
				
				if(UnitName(name) ~= nil and UnitIsEnemy("player", name) and (not UnitIsDead(name))
					and (UnitHealth(name) < lowestHP)) then
					lowestId = i;
					lowestHP = UnitHealth(name);
				end
			end
			
			if(lowestId ~= -1) then
				TargetUnit("raid"..lowestId.."target");
			end
		
		elseif(numPartyMembers > 0) then
		
			local lowestId = -1;
			-- the enemy's Hp will be in a range from 0-100.
			local lowestHP = 200;
			
			for i=1, numPartyMembers, 1 do
				local name = "party"..i.."target";
				
				if(UnitName(name) ~= nil and UnitIsEnemy("player", name) and (not UnitIsDead(name))
					and (UnitHealth(name) < lowestHP)) then
					lowestId = i;
					lowestHP = UnitHealth(name);
				end				
			end		
			
			if(lowestId ~= -1) then
				TargetUnit("party"..lowestId.."target");
			end
		end
	end;
	
-- assist the first MT that is targetting something useful...ie, its alive and an enemy	
-- if they all stink, assist mtOne.
	Assist = function(mtOne, mtTwo, mtThree)
	
		if(mtOne ~= "") then
			TargetByName(mtOne);
			AssistUnit("target");
		end
		
		if(UnitIsEnemy("player", "target") and not UnitIsDead("target")) then
			return;
		end
		
		if(mtTwo ~= "") then
			TargetByName(mtTwo);
			AssistUnit("target");
		end
		
		if(UnitIsEnemy("player", "target") and not UnitIsDead("target")) then
			return;
		end
		
		if(mtThree ~= "") then
			TargetByName(mtThree);
			AssistUnit("target");
		end
		
		if(UnitIsEnemy("player", "target") and not UnitIsDead("target")) then
			return;
		end
		
		-- if they all stink, assist MT one.
		TargetByName(mtOne);
		AssistUnit("target");
	end;
	
	-- wrote this as an easy way to set the three person assist macro above.
	-- num is which macro number your editing....  Usually 1, mine happens to be 2.
	SetAssistThree = function(num)
		local mtOne = "";
		local mtTwo = "";
		local mtThree = "";
		local totalNumber = -1;
		local name = "";
		
		if(GetNumRaidMembers() > 0) then
			totalNumber = GetNumRaidMembers();
			name = "raid";
		end
		
		if(totalNumber == -1) then
			totalNumber = GetNumPartyMembers();
			
			if(totalNumber > 0) then
				name = "party";
			end
		end
		
		if(UnitName("target") ~= nil) then
			mtOne = UnitName("target");
		end
		
		if(totalNumber > 0) then		
			for i=1, totalNumber, 1 do
				local playerClass, englishClass = UnitClass(name..i);
				
				if(englishClass == "WARRIOR") then
					if(mtOne == "") then
						mtOne = UnitName(name..i);
					elseif(mtTwo == "" and UnitName(name..i) ~= mtOne) then
						mtTwo = UnitName(name..i);
					elseif(mtThree == "" and UnitName(name..i) ~= mtOne and UnitName(name..i) ~= mtTwo) then
						mtThree = UnitName(name..i);
					else
						break;
					end
				end
			end
		end
		
		AssistTanks[1] = mtOne;
		AssistTanks[2] = mtTwo;
		AssistTanks[3] = mtThree;
		
		AssistMT.tooltiptext = ASSISTMT_TOOLTIP.." "..mtOne;
		if(num ~= -1) then
			EditMacro(num, ASSISTMT_TOOLTIP.." "..mtOne, nil, "/script FFunc.Assist(\""..mtOne.."\",\""..mtTwo.."\",\""..mtThree.."\");", 1);
		end
	end;
	
	AssistGreatestHP = function()
		local numRaidMembers = GetNumRaidMembers();
		local numPartyMembers = GetNumPartyMembers();
	
		if(numRaidMembers > 0) then
			local highestId = -1;
			local highestHP = 0;
			
			for i=1, numRaidMembers, 1 do
				local name = "raid"..i.."target";
				
				if(UnitName(name) ~= nil and UnitIsEnemy("player", name) and (not UnitIsDead(name))
					and (UnitHealth(name) > highestHP)) then
					highestId = i;
					highestHP = UnitHealth(name);
				end
				
				if(highestHP == 100) then
					break;
				end
			end
			
			if(highestId ~= -1) then
				TargetUnit("raid"..highestId.."target");
			end
		
		elseif(numPartyMembers > 0) then
		
			local highestId = -1;
			-- the enemy's Hp will be in a range from 0-100.
			local highestHP = 0;
			
			for i=1, numPartyMembers, 1 do
				local name = "party"..i.."target";
				
				if(UnitName(name) ~= nil and UnitIsEnemy("player", name) and (not UnitIsDead(name))
					and (UnitHealth(name) > highestHP)) then
					highestId = i;
					highestHP = UnitHealth(name);
				end	
				
				if(highestHP == 100) then
					break;
				end		
			end		
			
			if(highestId ~= -1) then
				TargetUnit("party"..highestId.."target");
			end
		end
	end;
	
	-- find the first corpse in your party or raid.
	TargetCorpse = function()
		local totalNumber = -1;
		local name = "";
		
		if(GetNumRaidMembers() > 0) then
			totalNumber = GetNumRaidMembers();
			name = "raid";
		end
		
		if(totalNumber == -1) then
			totalNumber = GetNumPartyMembers();
			
			if(totalNumber > 0) then
				name = "party";
			end
		end
		
		if(totalNumber > 0) then		
			for i=1, totalNumber, 1 do
				if(UnitIsDeadOrGhost(name..i)) then
					TargetUnit(name..i);
					break;
				end	
		
			-- doesn't work because you can't target objects...
			--[[	if(UnitIsDead(name..i) and not UnitIsGhost(name..i)) then
					TargetUnit(name..i);
					break;
				elseif(UnitIsDeadOrGhost(name..i)) then
					TargetByName("Corpse of "..UnitName(name..i));
					break;
				end]]--
			end			
		end
	end;
	
	TargetLowestHP = function()
		local numRaidMembers = GetNumRaidMembers();
		local numPartyMembers = GetNumPartyMembers();
	
		if(numRaidMembers > 0) then
			local lowestId = -1;
			local lowestHP = 20000;
			
			for i=1, numRaidMembers, 1 do
				local name = "raid"..i;
				
				if(UnitName(name) ~= nil and (not UnitIsDeadOrGhost(name))
					and (UnitHealth(name) < lowestHP)) then
					lowestId = i;
					lowestHP = UnitHealth(name);
				end
			end
			
			if(lowestId ~= -1) then
				TargetUnit("raid"..lowestId);
			end
		
		elseif(numPartyMembers > 0) then
		
			local lowestId = -1;
			local lowestHP = 20000;
			
			for i=1, numPartyMembers, 1 do
				local name = "party"..i;
				
				if(UnitName(name) ~= nil and (not UnitIsDeadOrGhost(name))
					and (UnitHealth(name) < lowestHP)) then
					lowestId = i;
					lowestHP = UnitHealth(name);
				end			
			end		
			
			if(lowestId ~= -1) then
				TargetUnit("party"..lowestId);
			end
		end
	end;
	
	TargetMostDamageTaken = function()
		local numRaidMembers = GetNumRaidMembers();
		local numPartyMembers = GetNumPartyMembers();
	
		if(numRaidMembers > 0) then
			local mostDamageId = -1;
			local mostDamage = 0;
			
			for i=1, numRaidMembers, 1 do
				local name = "raid"..i;
				
				if(UnitName(name) ~= nil and (not UnitIsDeadOrGhost(name))) then
					local tempDamage = UnitHealthMax(name) - UnitHealth(name);
					
					if(tempDamage > mostDamage) then
						mostDamageId = i;
						mostDamage = tempDamage;
					end
				end
			end
			
			if(mostDamageId ~= -1) then
				TargetUnit("raid"..mostDamageId);
			end
		
		elseif(numPartyMembers > 0) then
		
			local mostDamageId = -1;
			local mostDamage = 0;
			
			for i=1, numPartyMembers, 1 do
				local name = "party"..i;
				
				if(UnitName(name) ~= nil and (not UnitIsDeadOrGhost(name))) then
					local tempDamage = UnitHealthMax(name) - UnitHealth(name);
					
					if(tempDamage > mostDamage) then
						mostDamageId = i;
						mostDamage = tempDamage;
					end
				end			
			end		
			
			if(mostDamageId ~= -1) then
				TargetUnit("party"..mostDamageId);
			end
		end
	end;
	
	-- essentially just a wrapper
	Cast = function(name)
		if(MaxLoaded == 0) then
			MaxLoaded = 1;
			FabFunctions_OnLoad();
		end
		-- disabled
		-- out of range
		-- has cooldown
		-- not enough mana
		
		CastSpellByName(name.."(Rank "..FFMaxSpellRanks[name]..")");
	end;
	
	TargetTotem = function(totemOne, totemTwo, totemThree, totemFour)
		TargetByName(totemOne.." Totem");
		if(UnitName("target") ~= nil) then
			return;
		end
		
		TargetByName(totemTwo.." Totem");
		if(UnitName("target") ~= nil) then
			return;
		end
		
		TargetByName(totemThree.." Totem");
		if(UnitName("target") ~= nil) then
			return;
		end
		
		TargetByName(totemFour.." Totem");
		if(UnitName("target") ~= nil) then
			return;
		end
		
		TargetByName("Totem");
	end;
};

Paladin = {

-- the blessing functions are here to deal with players being too low of a level.
-- rank is the highest rank you know.
	BlessMight = function()
		local RankLevels = {4, 12, 22, 32, 42, 52};
		
		Misc.CastBuffSpell("Blessing of Might", RankLevels, 6);
	end;
	
	BlessWisdom = function()
		local RankLevels = {14, 24, 34, 44, 54};
		
		Misc.CastBuffSpell("Blessing of Wisdom", RankLevels, 5);
	end;
	
	BlessSanctuary = function()
		local RankLevels = {20, 30, 40, 50, 60};
		
		Misc.CastBuffSpell("Blessing of Sanctuary", RankLevels, 5);
	end;
	
	BlessLight = function()
		local RankLevels = {40, 50, 60};
		
		Misc.CastBuffSpell("Blessing of Light", RankLevels, 3);
	end;
	
	-- I only added this because of how it defaults to casting on the player
	BlessProtection = function()
		local RankLevels = {10, 24, 38};
		
		Misc.CastBuffSpell("Blessing of Protection", RankLevels, 3);
	end;
	
-- All the healing spell maxes are tailored for a lvl 60
	HolyLight = function()
		-- the max the spell can heal for.
		local HealLevels = {51, 96, 196, 368, 569, 799, 1076, 1414};
		local LowLevels = {39, 76, 159, 310, 491, 698, 945, 1246}
		local RankLevels = {1, 6, 14, 22, 30, 38, 46, 54};
		local MaxRank = 8;
		--local HealerSpeccedLevels = {57, 107, 219, 412, 637, 894, 1205, 1583};
		
		
		local nameTalent, iconPath, iconX, iconY, currentRank, maxRank = GetTalentInfo(1, 3);
		
		currentRank = currentRank * .12;
		currentRank = currentRank + 1;
		
		for j = 1, MaxRank, 1 do
			HealLevels[j] = HealLevels[j] * currentRank;
			LowLevels[j] = LowLevels[j] * currentRank;
			
			HealLevels[j] = (HealLevels[j]+LowLevels[j])/2;
		end
		
		Misc.CastHealSpell("Holy Light", HealLevels, RankLevels, 8);
	end;
	
	FlashOfLight = function()
		-- the max the spell can heal for.
		local HealLevels = {(62+77)/2, (96+117)/2, (145+171)/2, (197+231)/2, (267+310)/2, (343+389)/2};
		local RankLevels = {20, 26, 34, 42, 50, 58};
		
		Misc.CastHealSpell("Flash of Light", HealLevels, RankLevels, 6);
	end;
};

Druid = {
	
	Thorns = function()
		local RankLevels = {6, 14, 24, 34, 44, 54};
		
		Misc.CastBuffSpell("Thorns", RankLevels, 6);
	end;
	
	MarkWild = function()
		local RankLevels = {1, 10, 20, 30, 40, 50, 60};
		
		Misc.CastBuffSpell("Mark of the Wild", RankLevels, 7);
	end;
	
	Rejuvenation = function()
		local RankLevels = {4, 10, 16, 22, 28, 34, 40, 46, 52};
		
		Misc.CastBuffSpell("Rejuvenation", RankLevels, 9);
	end;
	
	HealingTouch = function()
		local HealLevels = {(37+51)/2, (88+112)/2, (195+243)/2,
			(363+445)/2, (572+694)/2, (742+894)/2, (936+1120)/2, (1199+1427)/2, (1516+1796)/2, (1890+2230)/2};
		local RankLevels = {1, 8, 14, 20, 26, 32, 38, 44, 50, 56};
		
		Misc.CastHealSpell("Healing Touch", HealLevels, RankLevels, 10);
	end;
	
	Regrowth = function()
		local HealLevels = {(84+98)/2, (164+188)/2, (240+274)/2, (318+360)/2, (405+457)/2, (511+575)/2, 
			(646+724)/2, (809+905)/2, (1003+1119)/2 };
		local RankLevels = {12, 18, 24, 30, 36, 42, 48, 54, 60};
		
		if((UnitName("target") == nil or Misc.IsEnemy("player", "target") or UnitIsUnit("player", "target")) and GetNumPartyMembers() <= 0 and GetNumRaidMembers() <= 0) then
			Misc.CastHealSpell("Regrowth", HealLevels, RankLevels, 9);
		else
			Misc.CastBuffSpell("Regrowth", RankLevels, 9);
		end
	end;
};

Priest = {

-- NOTE TO SELF:  Priest needs some sort of function that chooses which heal....
-- chooses between lesser, heal, and greater.

	Shield = function()
		local RankLevels = {6, 12, 18, 24, 30, 36, 42, 48, 54, 60};
		
		Misc.CastBuffSpell("Power Word: Shield", RankLevels, 10);
	end;

	Fortitude = function()
		local RankLevels = {1, 12, 24, 36, 48, 60};
		
		Misc.CastBuffSpell("Power Word: Fortitude", RankLevels, 6);
	end;
	
	ShadowProtection = function()
		local RankLevels = {30, 42, 56};
		
		Misc.CastBuffSpell("Shadow Protection", RankLevels, 3);
	end;
	
	Renew = function()
		local RankLevels = {8, 14, 20, 26, 32, 38, 44, 50, 56};
		
		Misc.CastBuffSpell("Renew", RankLevels, 9);
	end;
	
	LesserHeal = function()
		local HealLevels = {(46+56)/2, (71+85)/2, (135+157)/2};
		local RankLevels = {1, 4, 10};
		
		Misc.CastHealSpell("Lesser Heal", HealLevels, RankLevels, 3);
	end;
	
	Heal = function()
		local HealLevels = {(295+341)/2, (499+571)/2, (754+856)/2, (948+1072)/2};
		local RankLevels = {16, 22, 28, 34};
		
		Misc.CastHealSpell("Heal", HealLevels, RankLevels, 4);
	end;
	
	GreaterHeal = function()
		local HealLevels = {(1201+1353)/2, (1531+1717)/2, (1919+2147)/2, (2396+2674)/2};
		local RankLevels = {40, 46, 52, 58};
		
		Misc.CastHealSpell("Greater Heal", HealLevels, RankLevels, 4);
	end;
	
	FlashHeal = function()
		local HealLevels = {(193+237)/2, (258+314)/2, (327+393)/2, (400+478)/2,
			(518+616)/2, (644+764)/2, (812+958)/2};
		local RankLevels = {20, 26, 32, 38, 44, 50, 56};
		
		Misc.CastHealSpell("Flash Heal", HealLevels, RankLevels, 7);
	end;
	
	DesperatePrayer = function()
	end;
};

Shaman = {

	HealingWave = function()
		local HealLevels = {(34+44)/2, (64+78)/2, (129+155)/2, (268+316)/2, (376+440)/2,
			(536+622)/2, (740+854)/2, (1017+1167)/2, (1367+1561)/2};
		local RankLevels = {1, 6, 12, 18, 24, 32, 40, 48, 56};
		
		Misc.CastHealSpell("Healing Wave", HealLevels, RankLevels, 9);
	end;
	
	LesserHealingWave = function()
		local HealLevels = {(162+186)/2, (247+281)/2, (337+381)/2, (458+514)/2, (631+705)/2, (832+928)/2};
		local RankLevels = {20, 28, 36, 44, 52, 60};
		
		Misc.CastHealSpell("Lesser Healing Wave", HealLevels, RankLevels, 6);
	end;
	
	ChainHeal = function()
		local HealLevels = {(320+368)/2, (405+465)/2, (551+629)/2};
		local RankLevels = {40, 46, 54};
		
		Misc.CastHealSpell("Chain Heal", HealLevels, RankLevels, 3);
	end;
};

Mage = {
	
	ArcaneIntellect = function()
		local RankLevels = {1, 14, 28, 42, 56};
		
		Misc.CastBuffSpell("Arcane Intellect", RankLevels, 5);
	end;
	
	AmplifyMagic = function()
		local RankLevels = {18, 30, 42, 54};
		
		Misc.CastBuffSpell("Amplify Magic", RankLevels, 4);
	end;
};
